/*

 questo sorgente e' parte integrante 
 del Progetto xSudoky.
 Scritto da Max Cavallo 20/Luglio/2007
 - modificato 16 Marzo 2008
 ixamit@gmail.com

*/

#include "sudoky.h"
#include <libintl.h>
#include <locale.h>

int label_Tipo;
int label_Found;

//====================================================
//
//-------------------------FISH ----------------------
//
//====================================================

int DeleteFish (int max, int Tipo, int Candidato, int y,int x, int posizioni, int fish)
{

    static char *fishing[]={
        "X-WING",
        "SWORD-FISH",
        "JELLY-FISH",
        "SQUIRM-BAG"};

    char buffref[132],*pbr;
    int r,c;

    pbr=buffref;


    //printf ("Found R%dC%d\n",y+1,x+1);
    if (label_Tipo++==0)
    {
        if (Tipo==1)
            sprintf (BUFF,gettext("%s in ROWS"),fishing[max-2]);
        else
            sprintf (BUFF,gettext("%s in COLUMNS"),fishing[max-2]);

        WX11_ListCmdItemAdd (ViewComment, LABEL,BUFF);
        label_Found=0;
    }

    if (label_Found++==0)
    {
        if (Tipo==1)
        {
            for (r=0;r<SUD_TAB;r++)
            {
                if (posizioni & (1<<r))
                {
                    for (c=0;c<SUD_TAB;c++)
                    {
                        if ((fish & (1<<c))&& SUD_BUF[r][c] & (1 << (Candidato-1)))
                        {
                            sprintf (pbr,"R%dC%d, ",r+1,c+1);
                            pbr+=6;
                        }
                    }
                }
	    }
        }
        if (Tipo==2)
        {
            for (c=0;c<SUD_TAB;c++)
            {
                if (posizioni & (1<<c))
                {
                    for (r=0;r<SUD_TAB;r++)
                    {
                        if ((fish & (1<<r))&& SUD_BUF[r][c] & (1 << (Candidato-1)))
                        {
                            sprintf (pbr,"R%dC%d, ",r+1,c+1);
                            pbr+=6;
                        }
                    }
                }
	    }

	}
	*(pbr-2)='\0'; pbr=buffref;

	sprintf (BUFF,gettext("  Found [%d] in %s"),Candidato,buffref);
	WX11_ListCmdItemAdd (ViewComment, LIST_BOX, BUFF);
    }

    sprintf (BUFF, gettext("    Unset [%d] in R%dC%d"),Candidato,y+1,x+1);
    WX11_ListCmdItemAdd (ViewComment, LIST_BOX, BUFF);

    RemoveCandidatoGUI(y,x,Candidato,0);

    return (0);
}

int ProcessFish (int max, int Tipo, int Candidato, int posizioni, int fish)
{
	int y,x,z;

	z=0;
	for (z=0;z<SUD_TAB;z++)
	{
		if (fish & (1<<z))
		{
			if (Tipo==1)
			{
				x=z;
				for (y=0;y<SUD_TAB;y++)
				{
					if (SUD_BUF[y][x] & (1<<(Candidato-1)) &&
						!(posizioni & (1<<y)))
					{
						
						DeleteFish (max,Tipo,Candidato, 	y,x,posizioni,fish);
					}
				}
			}
			if (Tipo==2)
			{
				y=z;
				for (x=0;x<SUD_TAB;x++)
				{
					if (SUD_BUF[y][x] & (1<<(Candidato-1)) &&
						!(posizioni & (1<<x)))
					{
						
						DeleteFish (max,Tipo,Candidato, 	y,x,posizioni,fish);
					}
				}
			}
		}
	}
	return 0;
}


int LookingFish (int max,int Tipo,int Candidato,int tmp[SUD_TAB])
{
	/*
		Looking 4 Fish pattern

		max 	2=X-Wing 3=SwordFish 4=Jelly-Fish 5=Squirm-Bag
		Tipo	1=Rows 2=Cols
		Candidato	1..9
		tmp[]	pattern candidate position 

	*/

	int k,z;
	int fishold,fish;	// bit pattern fish
	int posizioni;		// bit rows or cols

	for (k=0;k<SUD_TAB;k++)
	{
		if (tmp[k])
		{
			fishold=0x0;fish=0x0;posizioni=0x0;
			label_Found=0;
			for (z=k+1;z<SUD_TAB;z++)
			{
				if (tmp[z])
				{
					fish=tmp[k]|tmp[z];
					if (!fishold) fishold=fish;

					if (ContaBits(fish)<=max && fishold==fish)
						posizioni|=1 << z;
				}
			}
			if (ContaBits(posizioni)==max-1 &&
				ContaBits(fishold)==max)
			{
				posizioni|=1 << k;

				ProcessFish (max,Tipo,Candidato,posizioni,fishold);
			}
		}
	}
	return 0;
}

int FishRows(int max)
{
	int x,y,k;
	int z;
	int tmp[SUD_TAB];

	label_Tipo=0;
	for (k=0;k<SUD_TAB;k++)
	{
		for (y=0;y<SUD_TAB;y++)
		{
			tmp[y]=0x0;
			for (x=0;x<SUD_TAB;x++)
			{
				if (SUD_BUF[y][x] & (1 << k))
				{
					if (IsCandi (y,x))
						tmp[y] |= (1 << x);
				}
			}
			z=ContaBits (tmp[y]);
			if (z<2 || z>max) tmp[y]=0;
		}
		LookingFish(max,1,k+1,tmp);
	}
	
	return (0);
}

int FishCols(int max)
{
	int x,y,k;
	int z;
	int tmp[SUD_TAB];

	label_Tipo=0;
	for (k=0;k<SUD_TAB;k++)
	{
		for (x=0;x<SUD_TAB;x++)
		{
			tmp[x]=0x0;
			for (y=0;y<SUD_TAB;y++)
			{
				if (SUD_BUF[y][x] & (1 << k))
				{
					if (IsCandi (y,x))
						tmp[x] |= (1 << y);
				}
			}
			z=ContaBits (tmp[x]);
			if (z<2 || z>max) tmp[x]=0;
		}
		LookingFish(max,2,k+1,tmp);
	}
	
	return (0);
}


int Fish ()
{
	int k;
	Clear_Comments ();

	for (k=2;k<=5;k++)
	{
		FishRows(k);
		FishCols(k);
	}

	SudoFinish(SOLVE_MODE);

	return (0);
}


