/*

 questo sorgente e' parte integrante 
 del Progetto xSudoky.
 Scritto da Max Cavallo 20/Luglio/2007
 ixamit@gmail.com

*/

#include "sudoky.h"
#include <libintl.h>
#include <locale.h>

//
//-------------------------------------------
//                   XY-WING
//-------------------------------------------
//
int XYWingRemoveCandidate (int Row,int Col, int Candidate)
{
	sprintf (BUFF, gettext("    Unset [%d] in R%dC%d"),Candidate,Row+1,Col+1);
	WX11_ListCmdItemAdd (ViewComment, LIST_BOX, BUFF);

	RemoveCandidatoGUI(Row,Col,Candidate,0);

	return (0);
}



int XYWingVerify1 (int Row,int Col,int Col1)
{
/*
	first method
	---------------------
	.....................
	...XY...........XZ...
	..................
	---------------------
	.....................
	...YZ............*...
	.....................
	---------------------
*/
	int y;
	int test;
	int xy,yz,xz,z;
	int c1,c2;
	int candi;
	
	// Verifica 1 solo candidato in comune
	test=(SUD_BUF[Row][Col] & SUD_BUF[Row][Col1]);
	UnsetFlagCandidato (&test, CANDI_MSK);
	if (ContaBits(test)!=1) return 0;


	xy=SUD_BUF[Row][Col];  
	xz=SUD_BUF[Row][Col1]; 
	yz=(xy|xz);          UnsetFlagCandidato (&yz, test);

	for (y=0;y<SUD_TAB;y++)
	{
		c1=0;c2=0;
		if (SUD_BUF[y][Col]==yz)
		{
			c1=Col; c2= Col1;
		}
		if (SUD_BUF[y][Col1]==yz)
		{
			c1=Col1; c2= Col;
		}
		if (c1 || c2)
		{
			z=SUD_BUF[y][c1] & yz;	UnsetFlagCandidato (&z, CANDI_MSK);
			candi=GetCandidato(z);

			if (IsCandiExist (y, c2, candi))
			{
				sprintf (BUFF,gettext("  Found R%dC%d R%dC%d R%dC%d"),
				Row+1,Col+1,Row+1,Col1+1,y+1,c1+1);

				WX11_ListCmdItemAdd (ViewComment, LIST_BOX, BUFF);

				XYWingRemoveCandidate (y,c2,candi);
			}
		}
		
	}

	return (0);
}

int XYWingMethod1()
{
	int y,x,x1;

	for (y=0;y<SUD_TAB;y++)
	{
		for (x=0;x<SUD_TAB;x++)
		{
			if (ContaBits(SUD_BUF[y][x])==2)
			{
				for (x1=x+1;x1<SUD_TAB;x1++)
				{
					if (ContaBits(SUD_BUF[y][x1])==2)
						XYWingVerify1 (y,x,x1);
				}
			}
		}
	}

	return (0);
}

int XYWingVerifyZ2 (int Row1, int Col1, int Row2, int Col2, int Row3, int Col3)
{
	int x,y,z,candi;
	int b1,p1,b2,p2,p;
	int flag=0;

	if (Row1==Row2 && Row1==Row3) return (0);// FIXME
	if (Col1==Col2 && Col1==Col3) return (0);// FIXME

	z=SUD_BUF[Row2][Col2] & SUD_BUF[Row3][Col3];	UnsetFlagCandidato (&z, CANDI_MSK);
	candi=GetCandidato(z);

	Coordinateyx2Blocco (Row2,Col2,&b1,&p1);
	Coordinateyx2Blocco (Row3,Col3,&b2,&p2);

	sprintf (BUFF, gettext("  Found R%dC%d R%dC%d R%dC%d"),	Row1+1,Col1+1,Row2+1,Col2+1,Row3+1,Col3+1);
	
	if (b1!=b2)
	{
		if (Row1==Row2)
		{
			for (z=0,p=((int)p1/3)*3;z<3;p++,z++)
			{
				CoordinateBlocco2yx (b2,p,&y,&x);
				if (IsCandiExist (y, x, candi))
				{
					if (!flag)
					{
						WX11_ListCmdItemAdd (ViewComment, LIST_BOX, BUFF);
						flag=!flag;
					}
					XYWingRemoveCandidate (y,x, candi);
				}
			}
			for (z=0,p=((int)p2/3)*3;z<3;p++,z++)
			{
				CoordinateBlocco2yx (b1,p,&y,&x);
				if (IsCandiExist (y, x, candi))
				{
					if (!flag)
					{
						WX11_ListCmdItemAdd (ViewComment, LIST_BOX, BUFF);
						flag=!flag;
					}
					XYWingRemoveCandidate (y,x, candi);
				}
			}
		}
		if (Col1==Col2)
		{
			for (z=0,p=(p1 % 3);z<3;p+=3,z++)
			{
				CoordinateBlocco2yx (b2,p,&y,&x);
				if (IsCandiExist (y, x, candi))
				{
					if (!flag)
					{
						WX11_ListCmdItemAdd (ViewComment, LIST_BOX, BUFF);
						flag=!flag;
					}
					XYWingRemoveCandidate (y,x, candi);
				}
			}
			for (z=0,p=(p2 % 3);z<3;p+=3,z++)
			{
				CoordinateBlocco2yx (b1,p,&y,&x);
				if (IsCandiExist (y, x, candi))
				{
					if (!flag)
					{
						WX11_ListCmdItemAdd (ViewComment, LIST_BOX, BUFF);
						flag=!flag;
					}
					XYWingRemoveCandidate (y,x, candi);
				}
			}

		}

	}
	
	return (0);
}

int XYWingVerify2 (int Row1, int Col1, int Row2, int Col2)
{
/*
	second method
	+---+---+---++---+---+---+
	! * |XY | * !!   !XZ !   |
	+---+---+---++---+---+---+
	!   !   !   !!   !   !   !
	+---+---+---++---+---+---+
	!YZ !   !   !! * ! * ! * !
	+---+---+---++---+---+---+

*/

	int y,x,b,p;
	int test;
	int xy,yz,xz;//,z;
	//int c1,c2;
	//int candi;

	// Verifica 1 solo candidato in comune
	test=(SUD_BUF[Row1][Col1] & SUD_BUF[Row2][Col2]);
	UnsetFlagCandidato (&test, CANDI_MSK);
	if (ContaBits(test)!=1) return 0;


	xy=SUD_BUF[Row1][Col1];  
	xz=SUD_BUF[Row2][Col2]; 
	yz=(xy|xz);          UnsetFlagCandidato (&yz, test);

		Coordinateyx2Blocco (Row1,Col1,&b,&p);
		for (p=0;p<SUD_TAB;p++)
		{
			CoordinateBlocco2yx (b,p,&y,&x);
			//if (y!=Row1 && SUD_BUF[y][x]==yz)
			if (SUD_BUF[y][x]==yz)
				XYWingVerifyZ2 (Row1, Col1, Row2, Col2, y, x);
		}
	
		Coordinateyx2Blocco (Row2,Col2,&b,&p);
		for (p=0;p<SUD_TAB;p++)
		{
			CoordinateBlocco2yx (b,p,&y,&x);
			//if (y!=Row2 && SUD_BUF[y][x]==yz)
			if (SUD_BUF[y][x]==yz)
				XYWingVerifyZ2 (Row2, Col2, Row1, Col1, y, x);
		}

	return (0);
}

int XYWingMethod2()
{
	int y,x,y1,x1;

	for (y=0;y<SUD_TAB;y++)
	{
		for (x=0;x<SUD_TAB;x++)
		{
			if (ContaBits(SUD_BUF[y][x])==2)
			{
				for (x1=x+1;x1<SUD_TAB;x1++)
				{
					if (ContaBits(SUD_BUF[y][x1])==2)
						XYWingVerify2 (y,x,y,x1);
				}
			}
		}
	}

	for (x=0;x<SUD_TAB;x++)
	{
		for (y=0;y<SUD_TAB;y++)
		{
			if (ContaBits(SUD_BUF[y][x])==2)
			{
				
				for (y1=y+1;y1<SUD_TAB;y1++)
				{
					if (ContaBits(SUD_BUF[y1][x])==2)
						XYWingVerify2 (y,x,y1,x);
				}
			}
		}
	}


	return (0);
}

int XYWing()
{
	Clear_Comments ();
	WX11_ListCmdItemAdd (ViewComment, LABEL, gettext("XY-WING"));

	XYWingMethod1();
	XYWingMethod2();

	SudoFinish(1);

	return (0);
}

//
//-------------------------------------------
//                   XYZ-WING
//-------------------------------------------
//
int XYZWingMethod()
{
    int y,x,x1,y1,Row,Col;
    int xyz, xz, yz, k;
    int b1,b2,b3,p1,p2,p3,px;
    int candi;

    for (y=0;y<SUD_TAB;y++)
    {
	for (x=0;x<SUD_TAB;x++)
	{
	    if (ContaBits(SUD_BUF[y][x])==3)
	    {
		xyz=SUD_BUF[y][x];
		for (x1=0;x1<SUD_TAB;x1++)
		{
		    if (ContaBits(SUD_BUF[y][x1])==2)
		    {
			if (ContaBits(SUD_BUF[y][x] & SUD_BUF[y][x1])==2)
			{
			    xz=SUD_BUF[y][x1];

			    for (y1=0;y1<SUD_TAB;y1++)
			    {
				if (ContaBits(SUD_BUF[y1][x])==2)
				{
				    if (ContaBits(SUD_BUF[y][x] & SUD_BUF[y1][x])==2)
				    {
					yz=SUD_BUF[y1][x];

					if (xz!=yz)
					{
					    Coordinateyx2Blocco (y,x,&b1,&p1);
					    Coordinateyx2Blocco (y,x1,&b2,&p2);
					    Coordinateyx2Blocco (y1,x,&b3,&p3);
					    if ((b1==b2 && b1!=b3) || (b1==b3 && b1!=b2))
					    {
						candi=xyz & xz & yz; UnsetFlagCandidato (&candi, CANDI_MSK); candi=GetCandidato(candi);
						if (b1==b2 && b1!=b3)
						{
						    for (k=0;k<3;k++)
						    {
							px=(p3 % 3)+(k*3);
							CoordinateBlocco2yx (b1,px,&Row,&Col);
							if (px!=p1 && IsCandiExist (Row, Col, candi))
							{
   							    sprintf (BUFF, gettext("  Found R%dC%d R%dC%d R%dC%d"),y+1,x+1,y+1,x1+1,y1+1,x+1);
							    WX11_ListCmdItemAdd (ViewComment, LIST_BOX, BUFF);
							    XYWingRemoveCandidate (Row,Col, candi);

							}
						    }
						}
						if (b1==b3 && b1!=b2)
						{
						    for (k=0;k<3;k++)
						    {
							px=(((int)p2/3)*3)+k;
						    	CoordinateBlocco2yx (b1,px,&Row,&Col);
							if (px!=p1 && IsCandiExist (Row, Col, candi))
							{
							    sprintf (BUFF, gettext("  Found R%dC%d R%dC%d R%dC%d"),y+1,x+1,y+1,x1+1,y1+1,x+1);
							    WX11_ListCmdItemAdd (ViewComment, LIST_BOX, BUFF);
							    XYWingRemoveCandidate (Row,Col, candi);
							}
						    }
						}
					   }
					}
				    }
				}
			    }	
			}
		    }
		}
	    }
	}
    }

    return (0);
}


int XYZWing()
{
	Clear_Comments ();
	WX11_ListCmdItemAdd (ViewComment, LABEL, gettext("XYZ-WING"));

	XYZWingMethod ();

	SudoFinish(1);

	return (0);
}
