#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <sys/stat.h>
/*
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
*/
char *upcase (char *line)
{
    //
    // Upcase Line
    //
    char *p;
    for (p=line;*p;p++)
	*p=( (int)*p > 96 && (int)*p <123 )  ? *p-' ' : *p;
    return (line);
}

int leftright_trim (char *line)
{
    //
    // Left and Right trim line
    // return initial pos line (0..len) or -1 blank or rem  
    //
    int p1=0;
    int p2=(strlen(line))-1;

    while (p2 && (line[p2]==' ' || line[p2]=='\n')) p2--;
    while (p1<p2 && line[p1]==' ') p1++;

    if (p2==0 || p1==p2 || line[p1]=='#')
        return (-1);

    line[p2+1]='\0';

    return (p1);

}

int extract_value (char *line)
{
    //
    // Search for egual sign
    // return first valid pos or -1 if error
    //
    int p1=0;
    int p2=(strlen(line))-1;

    while (p1<p2 && line[p1] != '=') p1++;

    p1++;
    while (p1<p2 && line[p1]==' ') p1++;

    if (p2==0 || p1>=p2)
        return (-1);


    return (p1);

}

int xsudoky_config_writing_file (int *COLOR_THEME, int *SHOWCANDI,int *SOLVE_MODE,int *FULL_GAME)
{
    FILE *file, *fopen();
    char *homeuser=getenv("HOME");
    char *buff;

    buff=malloc(128);

    //
    // '.xphonya' directory exist?
    //
    sprintf (buff,"%s/.xsudoky",homeuser);
    file = fopen(buff, "r");
    if (!file)
    {
        //
        // if not exist create directory
        //
        mkdir(buff,0700);
    }
    else
    {
        fclose (file);
    }


    sprintf (buff,"%s/.xsudoky/config",homeuser);
    file = fopen(buff, "w");
    if (!file)
    {
        //
        // Error
        //
        printf ("Cannot Create %s file\n",buff);
        free(buff);
        return (-1);
    }
    //
    // defualt parameters
    //
    printf ("Writing xsudoky config (%s)\n",buff);
    //
    fputs("#\n# xsudoky - config\n#\n\n",file);
    //
    // write defaults
    //
    fprintf(file,"#\n# Defaults \n#\nCOLOR_THEME=%s\nSHOW_CANDIDATES=%s\nFULL_GAME=%s\nSOLVE_MODE=%s\n\n",(*COLOR_THEME) ? "Blue" : "Dark",(*SHOWCANDI) ? "yes" : "no",(*FULL_GAME) ? "yes" : "no",(*SOLVE_MODE) ? "yes" : "no");
    //
    //
    fclose (file);
    free(buff);
    //
    //xsudoky_config_reading_file ();
    //
    return (0); 
}
int xsudoky_config_reading_file (int *COLOR_THEME, int *SHOWCANDI,int *SOLVE_MODE,int *FULL_GAME)
{
    //
    //
    //
    FILE *file, *fopen();
    char *homeuser=getenv("HOME");
    char *buff;
    int pos=0, pos2=0;
    //
    int err=0; 

    buff=malloc(128);

    //
    // 'config' file exist?
    //
    sprintf (buff,"%s/.xsudoky/config",homeuser);
    file = fopen(buff, "r");
    if (file)
    {
        //
        // if file exist reading parameters
        //
        printf ("Reading xsudoky config (%s)\n",buff);
        while (!feof(file))
        {
            if (fgets(buff, 128, file)!=NULL)
            {
		err=0;
                pos=leftright_trim (buff);
		
                if (pos >= 0)
                {
                    if (!strncmp(buff+pos, "COLOR_THEME",11))
		    {
                        pos2=extract_value (buff+pos);
                        if (pos2 >= 0)
                        {
                            printf ("\tCOLOR_THEME=%s\n",buff+pos+pos2);
			    upcase(buff+pos+pos2);
			    if (strcmp(buff+pos+pos2,"DARK")==0 || strcmp(buff+pos+pos2,"BLUE")==0)
				*COLOR_THEME=(strcmp(buff+pos+pos2,"DARK")==0) ? 1 : 0;
			    else
				err=1;	
                        }
                        if (pos2==-1 || err)
                            printf ("\tinvalid COLOR_THEME value\n");
                    }
                    else if (!strncmp(buff+pos, "SHOW_CANDIDATES",15))
		    {
                        pos2=extract_value (buff+pos);
                        if (pos2 >= 0)
                        {
                            printf ("\tSHOW_CANDIDATES=%s\n",buff+pos+pos2);
			    upcase(buff+pos+pos2);
			    if (strcmp(buff+pos+pos2,"YES")==0 || strcmp(buff+pos+pos2,"NO")==0)
				*SHOWCANDI=(strcmp(buff+pos+pos2,"YES")==0) ? 1 : 0;
			    else
				err=1;	
                        }
                        if (pos2==-1 || err)
                            printf ("\tinvalid SHOW_CANDIDATES value\n");
                    }
                    else if (!strncmp(buff+pos, "FULL_GAME",9))
		    {
                        pos2=extract_value (buff+pos);
                        if (pos2 >= 0)
                        {
                            printf ("\tFULL_GAME=%s\n",buff+pos+pos2);
			    upcase(buff+pos+pos2);
			    if (strcmp(buff+pos+pos2,"YES")==0 || strcmp(buff+pos+pos2,"NO")==0)
				*FULL_GAME=(strcmp(buff+pos+pos2,"YES")==0) ? 1 : 0;
			    else
				err=1;
                        }
                        if (pos2==-1 || err)
                            printf ("\tinvalid FULL_GAME value\n");
                    }
                    else if (!strncmp(buff+pos, "SOLVE_MODE",10))
		    {
                        pos2=extract_value (buff+pos);
                        if (pos2 >= 0)
                        {
                            printf ("\tSOLVE_MODE=%s\n",buff+pos+pos2);
			    upcase(buff+pos+pos2);
			    if (strcmp(buff+pos+pos2,"YES")==0 || strcmp(buff+pos+pos2,"NO")==0)
				*SOLVE_MODE=(strcmp(buff+pos+pos2,"YES")==0) ? 1 : 0;
			    else
				err=1;
                        }
                        if (pos2==-1 || err)
                            printf ("\tinvalid SOLVE_MODE value\n");
                    }
                    else
                    {
                        printf ("\tInvalid: <%s>\n",buff+pos);
                    }
                }
            }
        }
        fclose (file);
        free(buff);
        return (0);
    }

    free(buff);
    xsudoky_config_writing_file (COLOR_THEME,SHOWCANDI,SOLVE_MODE,FULL_GAME);

    return (0);
}
