/*

 Gestione GUI 
 questo sorgente e' parte integrante 
 del Progetto xSudoky.
 Scritto da Max Cavallo 20/Luglio/2007
 ixamit@gmail.com

*/

#include "sudoky.h"
extern int WX11_INTERLINE_SPACE;

Timer *timer_s;
char ctimer[30];

void debug ()
{
	int y,x;
	//
	for (y=0;y<SUD_TAB;y++)
	{
		for (x=0;x<SUD_TAB;x++)
		{
			if (IsCandi (y,x))
				printf ("c");
			else if (!IsFixed (y,x))
				printf ("u");
			printf ("%s ",GetCandidati(y,x));
		}
		printf ("\n");
	}
	printf ("\n");
}

void sudoStoreName ()
{
	sprintf (BUFF,"%s - %s",FILENAME,PACKAGE);
	XStoreName(WX11_GetDisplay(), PrimoComando(0,NULL)->win, BUFF);
}

char *celldisplay (int y, int x)
{
	static char out[18];
	char *in=GetCandidati(y,x);
	char *tmp,*p;

	if (!IsCandi (y,x)) return (in);
	if (!SHOW_CANDI) return (" ");

	tmp=malloc(18);
	if (!tmp) return (" ");
	//           123456 789012 345678
	memcpy (tmp,"     \n     \n     \0",18);
	p=in;
	for (p=in;*p;p++)
		tmp[(*p-49)*2]=*p; 
		//tmp[(*p-49)*2]='o';

	memcpy (out,tmp,18);
	free (tmp);

	return (out);

}


int Redisplay (int Mode)
{
	//
	// Ricarica Display
	//
	int y,x;
	CmdInfo *cella;

	//return;

	for (y=0;y<SUD_TAB;y++)
	{
		for (x=0;x<SUD_TAB;x++)
		{
			sprintf (BUFF,"X%d%d",y,x);
			cella=CercaNomeComando (BUFF);
			if (IsCandi (y,x))
			{
				cella->Tipo=AREA;
				cella->Fg=CANDI_COLOR;
				WX11_FontSetCmd (cella,FONTSMALL);
				
			}
			else
			{
				cella->Tipo=BUTTON;
				cella->Fg=IsFixed (y,x) ? FIXED_COLOR : CANDI_COLOR;
				WX11_FontSetCmd (cella,FONTBIG);
				
			}
			if (IsEvidence(y,x))
			{
				cella->Bg=EVIDENCE_BG;
				WX11_ColorBackgroundSet (cella, EVIDENCE_BG, EVIDENCE_BG);
			}
			else
				SetCellBackGroundColor (cella);

			WX11_CmdLabelChange (cella,celldisplay(y,x));
		}
	}
	WX11_PrintFlush(NULL);
	if (Mode==0) SudoFinish (0);
	return (0);
}

int ResetGame (int value)
{
	//
	// Reset
	//
	int x,y;
	VUOTI=(SUD_TAB * SUD_TAB);

	for (y=0;y<SUD_TAB;y++)
		for (x=0;x<SUD_TAB;x++)	
			SUD_BUF[y][x]=value;

	return (0);
}

int SudoFinish (int Save)
{
	int ret=0;

	WX11_ListCmdItemAdd (ViewComment, LABEL,"-- Break --");

	WX11_FontOpen (FONTCOMMENT);
	WX11_ListBoxRefresh (ViewComment);
	WX11_FontOpen (FONTDEFAULT);

	sprintf (vuoti,"%2d ",VUOTI);
	WX11_CmdLabelChange(label_vuoti,vuoti);
	
	CheckAll();

	if (Save && (ViewComment->NumeroItem>2))
		DoSaved();

	if (VUOTI==0 && !timer_s->STOP)
	{
		TimerStop(timer_s);
		WX11_Alert (
			gettext("Game Resolved"),
			gettext("Ok"),NULL);
		SudokuNuovo ("");
		ret=0;
	}

	return (ret);
}

void Clear_Comments ()
{
	xClearAllListBoxItem (ViewComment);
}

int RemoveCandidatoGUI(int y,int x,int candidato,int step)
{
	CmdInfo *cella;
	int riga,colonna,blocco,pos,r,c;
	int save;

	if (!SOLVE_MODE) return (0);

	// Esce se NON e' candidato
	if (!IsCandi (y,x)) 
		return (0);

	// Esce se candidato unico
	if (IsOnly1Candi(SUD_BUF[y][x]))
		return (0);

	// Esce se NON rimosso
	save=SUD_BUF[y][x];
	RemoveCandidato (&SUD_BUF[y][x], candidato);
	if (save==SUD_BUF[y][x]) 
		return (0);

	// Rintraccia la cella
	sprintf(BUFF,"X%d%d",y,x);
	cella=CercaNomeComando (BUFF);


	WX11_CmdLabelChange (cella,celldisplay(y,x));

	if (candidato==EVIDENCE)
		SetCellBackGroundColor (cella);

	// Se + di 1 candidato rimanente esce
	if (ContaBits(SUD_BUF[y][x])>1)
		return (0);

	if (step==0) step=1;

	if (step==1)
	{
		candidato=atoi(GetCandidati(y,x));
		for (colonna=0;colonna<SUD_TAB;colonna++)
			RemoveCandidatoGUI(y,colonna,candidato,1);
		step=2;
	}
	if (step==2)
	{
		candidato=atoi(GetCandidati(y,x));
		for (riga=0;riga<SUD_TAB;riga++)
			RemoveCandidatoGUI(riga,x,candidato,2);
		step=3;
	}
	if (step==3)
	{
		candidato=atoi(GetCandidati(y,x));
		Coordinateyx2Blocco (y,x,&blocco,&pos);
		for (pos=0;pos<SUD_TAB;pos++)
		{
			CoordinateBlocco2yx (blocco,pos, &r, &c);
			RemoveCandidatoGUI(r,c,candidato,3);
		}
		step=3;
	}
	
	return (0);

}

int InsertNumeroGUI(int y,int x,int candidato,int step)
{
	CmdInfo *cella;
	int riga,colonna,blocco,pos,r,c;

	if (!SOLVE_MODE) return (0);

	SUD_BUF[y][x]=0x0;
	AddCandidato (&SUD_BUF[y][x], candidato);
	UnsetFlagCandidato (&SUD_BUF[y][x], CANDI_MSK);

	sprintf(BUFF,"X%d%d",y,x);
	cella=CercaNomeComando (BUFF);
	cella->Tipo=BUTTON;
	cella->Fg=CANDI_COLOR;
	WX11_FontSetCmd (cella,FONTBIG);
	WX11_CmdLabelChange (cella,celldisplay(y,x));

	if (candidato!=EVIDENCE)
		SetCellBackGroundColor (cella);	

	VUOTI--;

	if (step==0) step=1;

	if (step==1)
	{
		candidato=atoi(GetCandidati(y,x));
		for (colonna=0;colonna<SUD_TAB;colonna++)
			RemoveCandidatoGUI(y,colonna,candidato,1);
		step=2;
	}
	if (step==2)
	{
		candidato=atoi(GetCandidati(y,x));
		for (riga=0;riga<SUD_TAB;riga++)
			RemoveCandidatoGUI(riga,x,candidato,2);
		step=3;
	}
	if (step==3)
	{
		candidato=atoi(GetCandidati(y,x));
		Coordinateyx2Blocco (y,x,&blocco,&pos);
		for (pos=0;pos<SUD_TAB;pos++)
		{
			CoordinateBlocco2yx (blocco,pos, &r, &c);
			RemoveCandidatoGUI(r,c,candidato,3);
		}
		step=4;
	}

	return (0);
}

int AskRealCandi (int oy,int ox)
{
	//
	// Called from SudoBtPressL 
	// nonfixed number 
	//
	int x,y,b,p;
	int candi;
	int new=0;	// bitmask
	int found=0;

	Coordinateyx2Blocco (oy,ox,&b,&p);

	for (candi=0;candi<SUD_TAB;candi++)
	{
		for (x=0;!found && x<SUD_TAB;x++)
		{
			if (IsOnly1Candi (SUD_BUF[oy][x]) && 
				CandiExist (SUD_BUF[oy][x],candi+1))
			{
				AddCandidato (&new,candi+1);
				found=1;
				break;
			}
		}
		for (y=0;!found && y<SUD_TAB;y++)
		{
			if (IsOnly1Candi (SUD_BUF[y][ox]) && 
				CandiExist (SUD_BUF[y][ox],candi+1))
			{
				AddCandidato (&new,candi+1);
				found=1;
				break;
			}
		}
		for (p=0;!found && p<SUD_TAB;p++)
		{
			CoordinateBlocco2yx (b,p,&y,&x);
			if (IsOnly1Candi (SUD_BUF[y][x]) && 
				CandiExist (SUD_BUF[y][x],candi+1))
			{
				AddCandidato (&new,candi+1);
				found=1;
				break;
			}
		}
		found=0;
	}
	
	new^=0x1ff;		// Inverte gli ultimi 9 bits
	new|=SUD_BUF[oy][ox];   // Setta anche il vecchio candidato

	return (new); 
}

int SudoBtPressL(CmdInfo *cella, int Eventype, char *par)
{
	//
	// Inserimento Manuale Numero
	//
	char candidati_old[SUD_TAB+1];
	int y,x,c;
	int solve_old;
	int replace=0;

	y=cella->Name[1]-'0';
	x=cella->Name[2]-'0';
	
	strcpy (candidati_old,GetCandidati(y,x));

	if (IsFixed (y,x))
	{
		WX11_Alert (
			gettext("This number is fixed!"),
			gettext("Ok"),NULL);
		return (0);

	}
	if (!IsCandi (y,x))
	{
		// FIXME 
		strcpy (candidati_old,GetCandidati2(AskRealCandi (y,x)));
		replace=1;
		//return (0);
	}
	if (par==NULL)
	{
		sprintf (BUFF,gettext("Cell R%dC%d [%s]\n \nNumber to insert? "),
		y+1,x+1,candidati_old);

		c=WX11_Alert (BUFF,"1","2","3","4","5","6","7","8","9",NULL);
		if (c==-1) return (0);
	}
	else
		c=(par[0])-48;

	if (strcmp(candidati_old,""))
	{ 
		if (strchr(candidati_old, c+'0')==0)
		{
			sprintf (BUFF,
				gettext("Warning!!!\n The Number [%d] in R%dC%d is not correct"),
				c,y+1,x+1);

			WX11_Alert (BUFF,
				gettext("Ok"),NULL);
			return (0);
		}
	}
	
	solve_old=SOLVE_MODE;SOLVE_MODE=1;
	if (replace) VUOTI++;
	InsertNumeroGUI(y,x,c,0);
	SOLVE_MODE=solve_old;

	Clear_Comments ();
	WX11_ListCmdItemAdd (ViewComment, LABEL,
		gettext("MANUAL INSERT"));
	sprintf (BUFF,
		gettext("  Set [%d] in R%dC%d"),c,y+1,x+1);
	WX11_ListCmdItemAdd (ViewComment, LIST_BOX, BUFF);
	SudoFinish(1);
	
	return (0);
}

int SudoCellOver(CmdInfo *cmd, int eventtype)
{
	static CmdInfo *last_cmd=NULL;

	Display *dpy=WX11_GetDisplay();
	GC gc=(cmd->gc) ? cmd->gc : WX11_GCGet();
	Window win=cmd->parent;
	int width=(cmd->Width)+((cmd->Bordo)*2)-1;
	int heigth=(cmd->Height)+((cmd->Bordo)*2)-1;

	if (eventtype==EnterNotify)
	{
		if (strcmp(cmd->Name,MOUSEOVER))
		{
			WX11_PrintFlush(last_cmd);
		}
		strcpy (MOUSEOVER,cmd->Name);
		last_cmd=cmd;
	}
		
	if (strcmp(cmd->Name,MOUSEOVER)==0)
		XDrawRectangle(dpy, win, gc, 0, 0, width, heigth);

	return (0);
}

int SudoBtPressR (CmdInfo *cella, int Eventype, char *par)
{
	//
	// Eliminazione Manuale Candidato
	//
	//CmdInfo *cella=UltimoComandoSelezionato(0,NULL);
	char candidati_old[SUD_TAB+1];
	int y,x,c;
	int solve_old;
	
	y=cella->Name[1]-'0';
	x=cella->Name[2]-'0';

	strcpy (candidati_old,GetCandidati(y,x));
	if (!IsCandi (y,x))
	{
		WX11_Alert (
			gettext("There are not candidates to remove"),
			gettext("Ok"),NULL);
		return (0);
	}
	if (IsOnly1Candi(SUD_BUF[y][x]))
	{
		WX11_Alert (
			gettext("Cannot remove single candidate"),
			gettext("Ok"),NULL);
		return (0);
	}

	if (par==NULL)
	{
		sprintf (BUFF,
			gettext("Cell R%dC%d [%s]\n \nCandidate to remove?"),
			y+1,x+1,candidati_old);

		c=WX11_Alert (BUFF,"1","2","3","4","5","6","7","8","9",NULL);
		if (c==-1) return (0);
	}
	else
		c=(par[0])-48;


	if (strchr(candidati_old, c+'0')==0)
	{
		sprintf (BUFF,
			gettext("Warning!!!\n The canditate [%d] in R%dC%d not exist"),
			c,y+1,x+1);

		WX11_Alert (BUFF,
			gettext("Ok"),NULL);
		return (0);
	}

	solve_old=SOLVE_MODE;SOLVE_MODE=1;
	RemoveCandidatoGUI(y,x,c,0);
	SOLVE_MODE=solve_old;

	Clear_Comments ();
	WX11_ListCmdItemAdd (ViewComment, LABEL,
		gettext("MANUAL REMOVE CANDIDATE"));
	sprintf (BUFF,
		gettext("  Unset [%d] in R%dC%d -> [%s]"),
		c,y+1,x+1,GetCandidati(y,x));
	WX11_ListCmdItemAdd (ViewComment, LIST_BOX, BUFF);
	SudoFinish(1);

	return (0);
}

void sudo_start ()
{
	//
	// Show the game
	//
	CmdInfo *cmd;
	int y,x,posy,posx;
	int dimsquare=35;
	int dimgap=2;
	int bordo=4;
	int type;
	unsigned int colorbg=WX11_ColorGet(BUTTONBG);
	unsigned int colorfg=WX11_ColorGet(BUTTONFG);


	posx=4+dimsquare+dimgap+bordo;posy=4;
	for (x=0;x<SUD_TAB;x++)
	{
		if (x && ((x % DIVX)==0)) 
			posx=posx+dimgap;

		sprintf (LABELCOLONNA[x],"C%d",x+1);

		cmd=ApreBottone(area_sudo,
			posx,
			posy,
			dimsquare,dimsquare,
			LABELCOLONNA[x]);

		AddNomeComando (cmd,LABELCOLONNA[x]);

		WX11_SetSignalCallBack (cmd,Button1Release,SudoEvidence,NULL);

		posx=posx+dimsquare+bordo;
	}
	posx=4;posy=(posy+dimsquare)+dimgap+bordo;
	for (y=0;y<SUD_TAB;y++)
	{
		if (y && ((y % DIVY)==0)) 
			posy=posy+dimgap;

		posx=4;
		sprintf (LABELRIGA[y],"R%d",y+1);

		WX11_FontOpen (FONTDEFAULT);
		cmd=ApreBottone(area_sudo,
			posx,
			posy,
			dimsquare,dimsquare,
			LABELRIGA[y]);

		AddNomeComando (cmd,LABELRIGA[y]);

		WX11_SetSignalCallBack (cmd,Button1Release,SudoEvidence,NULL);

		posx=posx+dimsquare+dimgap+bordo; 
		for (x=0;x<SUD_TAB;x++)
		{
			if (x && ((x % DIVX)==0)) 
				posx=posx+dimgap;

			if (IsCandi (y,x))
			{
				type=AREA;
				WX11_FontOpen (FONTSMALL);
				colorfg=CANDI_COLOR;
			}
			else
			{
				type=BUTTON;
				WX11_FontOpen (FONTBIG);
				colorfg=IsFixed (y,x) ? FIXED_COLOR : CANDI_COLOR;
			}

			cmd=WX11_CmdOpen (type, area_sudo, posx, posy, dimsquare, dimsquare, colorbg, colorfg, 2, celldisplay(y,x));
			cmd->BUpDn=1;
			cmd->IsButton=1;

			// Signal Events
                        WX11_SetSignalCallBack (cmd,Button1Release,SudoBtPressL,NULL);
			WX11_SetSignalCallBack (cmd,Button3Release,SudoBtPressR,NULL);
			WX11_SetSignalCallBack (cmd,Expose,SudoCellOver,NULL);
			WX11_SetSignalCallBack (cmd,EnterNotify,SudoCellOver,NULL);
			WX11_SetSignalCallBack (cmd,LeaveNotify,SudoCellOver,NULL);
			
			// Assegna Nome (yx) 2 char
			sprintf (LABELCELL+(y*SUD_TAB*5)+(x*5),"X%d%d",y,x);
			AddNomeComando (cmd,LABELCELL+(y*SUD_TAB*5)+(x*5));

			// 
			SetCellBackGroundColor (cmd);


			posx=posx+dimsquare+bordo;
		}
		posy=posy+dimsquare+bordo;
	}

	WX11_FontOpen (FONTDEFAULT);

}


int SudokySHOW_CANDI ()
{
	//
	// Swap to Hidden/Show Candi
	//
	if (SHOW_CANDI)
                sprintf (BUFF,gettext("Hidden candidates"));
	if (!SHOW_CANDI)
                sprintf (BUFF,gettext("Show candidates"));
	//
	//WX11_ListCmdItemAdd (ViewComment, LABEL, BUFF);

	Redisplay (1);
        //
	return (0);
}

int SudokyFullHalfTable (CmdInfo *Cmd)
{
	//
	unsigned int Width,Height;
	CmdInfo *first_cmd=PrimoComando(0,NULL);
	XSizeHints hints;
	
	if (first_cmd->Tipo!=MAIN) return (0);

	
	Height=first_cmd->Height;

	Width=(FULL_GAME) ? 790 : 420;

	hints.flags = PSize | PMinSize | PMaxSize;
	//
	hints.width=Width;
	hints.height=Height;
	hints.min_width = hints.max_width = Width;
	hints.min_height= hints.max_height = Height;
	//
	XSetWMNormalHints(WX11_GetDisplay(), first_cmd->win, &hints);
	//
	XResizeWindow(WX11_GetDisplay(), first_cmd->win, Width, first_cmd->Height);
	//
        return (0);
	
}

int SudokyDeduceSolve (CmdInfo *Cmd)
{

	SOLVE_MODE=!SOLVE_MODE;
        return (0);
}

int ReadReadMe ()
{
	char *fname="README";
	char *lang;
	char freadme[64];

	strcpy (freadme,fname);
	lang=getenv("LANG");
	if (lang) 
	{
		lang[2]='\0';
		sprintf (freadme,"%s/%s/LC_MESSAGES/%s",DIR_PO,lang,fname);
	}
	else
		sprintf (freadme,"%s/%s/LC_MESSAGES/%s",DIR_PO,"en",fname);

	printf ("%s\n",freadme);
	WX11_ViewFile (freadme,fname,400,400);

	return (0);
}

void SudoSymmetry ()
{
	int Type=IsSymmetric ();
	//
	if (Type==0x00)
	{
		sprintf (BUFF,gettext("Warning!!! The puzzle has not Symmetry")); 
		WX11_ListCmdItemAdd (ViewComment, LABEL, BUFF);
	}
	if (Type==0x3F)
	{
		sprintf (BUFF,gettext("The puzzle has a full dihedral symmetry.")); 
		WX11_ListCmdItemAdd (ViewComment, LABEL, BUFF);
		Type=0;
	}
	if (Type&32)
	{
		sprintf (BUFF,gettext("The puzzle has a Full rotational symmetry")); 
		WX11_ListCmdItemAdd (ViewComment, LABEL, BUFF);
		Type=0;
	}
	if (Type&16)
	{
		sprintf (BUFF,gettext("The puzzle has a Horizzontal and Vertical reflection symmetry")); 
		WX11_ListCmdItemAdd (ViewComment, LABEL, BUFF);
		Type=0;
	}
	if (Type&8)
	{
		sprintf (BUFF,gettext("The puzzle has a Diagonal and anti-diagonal reflection symmetry")); 
		WX11_ListCmdItemAdd (ViewComment, LABEL, BUFF);
		Type=0;
	}
	if (Type&4)
	{
		sprintf (BUFF,gettext("The puzzle has 180%c rotational symmetry"),176); 
		WX11_ListCmdItemAdd (ViewComment, LABEL, BUFF);
		Type=0;
	}
	if (Type&2)
	{
		sprintf (BUFF,gettext("The puzzle has Horizzontal or Vertical reflection")); 
		WX11_ListCmdItemAdd (ViewComment, LABEL, BUFF);
		Type=0;
	}
	if (Type&1)
	{
		sprintf (BUFF,gettext("The puzzle has Diagonal or anti-diagonal reflection")); 
		WX11_ListCmdItemAdd (ViewComment, LABEL, BUFF);
		Type=0;
	}

}

int SudokuNuovo (char *firsttime)
{
	//
	// Load Random File
	//
	int RandomFile ();

	if (firsttime) 
	{
		if (WX11_Alert (
			gettext("Do you want to begin a new game?"),
			gettext("Yes"),gettext("No"),NULL)!=1)
			return (0);
	}

	strcpy (FILENAME," ");
	//
	CORSAVED=0;MAXSAVED=0;
	ResetGame (0x00);

	Clear_Comments ();

	RandomFile();
		
	Redisplay(0);
	//
	DoSaved ();
	//
	sudoStoreName ();
	//
	sprintf (vuoti,"%2d ",VUOTI);
	WX11_CmdLabelChange(label_vuoti,vuoti);
	//
	TimerStart (timer_s);

	firsttime=0;

	return (0);
}

int SudokuLoad (char *file)
{
	//
	// Nuovo Giovo
	//
	CORSAVED=0;MAXSAVED=0;
	ResetGame (0x00);

	Clear_Comments ();

	if (CaricaGame (file)) 
		return (1);

	SudoSymmetry ();
	RemoveCandidati ();

	extract_filename (file,FILENAME);
	sudoStoreName ();
	// 
	sprintf (vuoti,"%2d ",VUOTI);
	WX11_CmdLabelChange(label_vuoti,vuoti);
	//
	DoSaved ();
	
	Redisplay(0);
	
	TimerStart (timer_s);

	return (0);
}


int SudokyApri ()
{
	char *CurFile=NULL;

	CurFile=WX11_Files(gettext(" Open...   "),DIR_GAMES,NULL);
	printf ("Loading %s\n",CurFile);
	if (CurFile==NULL) return (0);
	
	if (SudokuLoad (CurFile))
	{
		printf ("Devo trappare\n");
	}

	return (0);
}

int SudokuCreate ()
{
	//
	// Create
	//
	if (WX11_Alert (
			gettext("Do you want to create a new game?"),
			gettext("Yes"),gettext("No"),NULL)!=1)
			return (0);

	TimerStop (timer_s);
	TimerStart (timer_s);

	strcpy (FILENAME,"No Name");
	CORSAVED=0;MAXSAVED=0;
	ResetGame (0x5ff);

	Clear_Comments ();

	SudoSymmetry ();
	// 
	sprintf (vuoti,"%2d ",VUOTI);
	//
	sudoStoreName ();
	//
	DoSaved ();
	
	Redisplay(0);
	//

	return (0);

}

int SudokySalva ()
{
	char *CurFile=NULL;
	//char *penv;

	//penv=getenv("HOME");
	//if (penv)
	//	CurFile=WX11_Files(gettext("Save..."),penv,NULL);
	//else
		CurFile=WX11_Files(gettext("Save..."), DIR_GAMES,NULL);

	if (CurFile==NULL) return (0);

	printf ("Saving %s\n",CurFile);

	Salva (CurFile);

	return (0);
}

int getrand (int toprange)
{
	//
	// Funzione Random
	//
	//
	static int f=0;
	if (!f)
	{
		srand (time (NULL));
		f=!f;
	}
	return (rand()/(int)(((unsigned)RAND_MAX + 1) / toprange));
}

int RandomFile ()
{
	struct dirent **files;
	int TotaleFiles,x;
	char CurFile[128];

	int sud_file_select();

	TotaleFiles=scandir(DIR_GAMES,&files,sud_file_select,alphasort);
	if (TotaleFiles==-1)
	{
		printf ("File(s) not found in %s\nPlease type 'make install' as root\n",DIR_GAMES);
		exit (1);
	}

	sprintf (CurFile,"%s/%s",DIR_GAMES,files[(getrand (TotaleFiles))]->d_name);

	for (x=0;x<TotaleFiles;x++) free(files[x]);
	free (files);

	extract_filename (CurFile,FILENAME);
	//
	printf ("Loading %s\n",CurFile);

	sprintf (BUFF,"Loading %s",FILENAME);
	WX11_ListCmdItemAdd (ViewComment, LABEL, BUFF);
	//
	CaricaGame (CurFile);
	SudoSymmetry ();
	// 
	RemoveCandidati ();
	// 
	return (0);
}

int sud_file_select(struct direct *entry)
{
	// 
	// Nota che questa funzione deve stare dopo la 
	// chiamata di scandir altrimenti genera un warning
	//
	char buff[64];
	struct stat stat_buf;

	sprintf (buff,"%s/%s",DIR_GAMES,entry->d_name);
	stat (buff,&stat_buf);
	if((stat_buf.st_mode & S_IFMT) == S_IFDIR)
		return (0);
	
	return (1);
}


int SudokyEnd ()
{
	int result;
	result=WX11_Alert (
		gettext("Do you want to exit?"),
		gettext("Yes"),
		gettext("No"),NULL);
	//
	result=(result==1) ? 1 : 0;

	return (result);
}

int SudoLicense()
{
	char *License=_DIR_DAT "LICENSE";

	WX11_ViewFile (License,"License",720,400);
	return (0);
}

int SudoHelp()
{
	char *lang;
	char fmethods[64];

	strcpy (fmethods,"METHODS");
	lang=getenv("LANG");
	if (lang) 
	{
		lang[2]='\0';
		sprintf (fmethods,"%s/%s/LC_MESSAGES/METHODS",DIR_PO,lang);
	}
	else
		sprintf (fmethods,"%s/%s/LC_MESSAGES/METHODS",DIR_PO,"en");

	WX11_ViewFile (FullPath(fmethods),NULL,550,400);
	return (0);
}

int SudoInfo()
{
	WX11_Alert (
            gettext("XSudoky 1.0.5\n \nWritten by Max Cavallo 2007-2009\n \nixamit@gmail.com\n \ncheck for a new version at\nhttp://xsudoky.sourceforge.net\n "),gettext("Ok"),NULL);
	return (0);
}

int SudoImpostaColore(char *mode)
{
	if (!mode) COLOR_THEME=!COLOR_THEME;

	if (COLOR_THEME)
	{
		EVIDENCE_BG=BLU_ACCIAIO;
		WX11_ColorSet (WINFG,BIANCO); WX11_ColorSet(WINBG,WX11_ColorDark(AZZURRO));
		WX11_ColorSet (BUTTONFG,BIANCO); WX11_ColorSet (BUTTONBG,WX11_ColorDark(AZZURRO));
		WX11_ColorSet (INPUTFG,GIALLO); WX11_ColorSet (INPUTBG,WX11_ColorDark(AZZURRO));	
		WX11_ColorSet (MENUFG,GIALLO); WX11_ColorSet (MENUBG,WX11_ColorDark(AZZURRO));
		WX11_ColorSet (LISTBOXFG,GIALLO); WX11_ColorSet (LISTBOXBG,WX11_ColorDark(AZZURRO));
	}
	else
	{
		EVIDENCE_BG=BLU_ARDESIA_SCURO;
		WX11_ColorSet (WINFG,GRIGIO20); WX11_ColorSet(WINBG,GRIGIO80);
		WX11_ColorSet (BUTTONFG,GRIGIO20); WX11_ColorSet (BUTTONBG,GRIGIO80);
		WX11_ColorSet (INPUTFG,GRIGIO10); WX11_ColorSet (INPUTBG,GRIGIO80);
		WX11_ColorSet (MENUFG,GRIGIO20); WX11_ColorSet (MENUBG,GRIGIO80);
		WX11_ColorSet (LISTBOXFG,GRIGIO20); WX11_ColorSet (LISTBOXBG,GRIGIO80);
	}

	WX11_ColorChange (NULL);
/*
	if (colore)
	{
		XSetWindowBackground(WX11_GetDisplay(), area_sudo->win, WX11_RGB(SMERALDO_SCURO));
		XSetWindowBackground(WX11_GetDisplay(), area_logo->win, WX11_RGB(SMERALDO_SCURO));
		area_sudo->Bg=SMERALDO_SCURO;
		area_logo->Bg=SMERALDO_SCURO;
		XClearWindow(WX11_GetDisplay(),area_sudo->win);
		XClearWindow(WX11_GetDisplay(),area_logo->win);
		WX11_PrintFlush(area_sudo);
		WX11_PrintFlush(area_logo);
	}
	else
	{
*/
		XSetWindowBackground(WX11_GetDisplay(), area_sudo->win, WX11_RGB(NERO));
		XSetWindowBackground(WX11_GetDisplay(), area_logo->win, WX11_RGB(NERO));
		area_sudo->Bg=NERO;
		area_logo->Bg=NERO;
		XClearWindow(WX11_GetDisplay(),area_sudo->win);
		XClearWindow(WX11_GetDisplay(),area_logo->win);
		WX11_PrintFlush(area_sudo);
		WX11_PrintFlush(area_logo);
//	}

	//
	//colore=!colore;
	Redisplay (1);
	return (0);

}

int SudoShowTime(CmdInfo *timer)
{
	struct timeval tv;
	time_t curtime;
	//
	tv=TimerWatch (timer_s);
	curtime=tv.tv_sec;
	strftime(ctimer,12,"%T",gmtime(&curtime));
	//sprintf (ctimer,"%s:%02d",BUFF,(int)tv.tv_usec/10000);

	WX11_CmdLabelChange (timer,ctimer);

	return (0);
}

int Sudokey (CmdInfo *cmd, unsigned int xsym, char *tasto, int state)
{
	CmdInfo *cella=NULL;
	CmdInfo *cella_old=NULL;
	int x=0;
	int y=0;

	// Dont trap opened menu 
	if (WX11_MenuCurrent (0,NULL)) return (0);
	// Dont trap if locked
	if (PrimoComando(0,NULL)->Lock) return (0);

	if (MOUSEOVER[0]=='X')
	{
		y=MOUSEOVER[1]-'0';
		x=MOUSEOVER[2]-'0';
	}

	//printf ("y=%d x=%d\n",y,x);

	sprintf (BUFF,"X%d%d",y,x);
	cella_old=CercaNomeComando (BUFF);

	if (*tasto=='n' || *tasto=='N')
	{
		if (WX11_IsCtrl (state) && (!WX11_IsShift (state))) SudokuNuovo ("");
	}
	if (*tasto=='o' || *tasto=='O')
	{
		if (WX11_IsCtrl (state) && (!WX11_IsShift (state))) SudokyApri ();
	}
	if (*tasto=='p' || *tasto=='P')
	{
		if (WX11_IsCtrl (state) && (!WX11_IsShift (state))) SudokyStampa ();
	}
	if (*tasto=='q' || *tasto=='Q')
	{
		if (WX11_IsCtrl (state) && (!WX11_IsShift (state))) SudokyEnd ();
	}
	if (*tasto=='s' || *tasto=='S')
	{
		if (WX11_IsCtrl (state) && (!WX11_IsShift (state))) SudokySalva ();
	}
	if (*tasto=='z' || *tasto=='Z')
	{
		if (WX11_IsCtrl (state))
		{
		 	if (WX11_IsShift (state)) 
				MoveSavedUp();
			else
				MoveSavedDn();
		}
	}
	if (xsym==XK_F9)
	{
		SHOW_CANDI=!SHOW_CANDI;
		SudokySHOW_CANDI();
		return (0);
	}
	if (xsym==XK_F11)
	{
		FULL_GAME=!FULL_GAME;
		SudokyFullHalfTable(cmd);
		return (0);
	}
	if (*tasto>48 && *tasto<58)
	{
		sprintf (BUFF,"X%d%d",y,x);
		cella=CercaNomeComando (BUFF);

		if (WX11_IsShift (state))
			SudoBtPressR(cella, Button1Release, (tasto));
		else
			SudoBtPressL(cella, Button1Release, (tasto));
	}
	if (xsym==XK_Up)
	{
		y--; if (y < 0) y=9-1;
		sprintf (BUFF,"X%d%d",y,x);
		cella=CercaNomeComando (BUFF);
	}
	if (xsym==XK_Down)
	{
		y++; if (y == 9) y=0;
		sprintf (BUFF,"X%d%d",y,x);
		cella=CercaNomeComando (BUFF);
	}
	if (xsym==XK_Left)
	{
		x--; if (x < 0) x=9-1;
		sprintf (BUFF,"X%d%d",y,x);
		cella=CercaNomeComando (BUFF);
	}
	if (xsym==XK_Right)
	{
		x++; if (x == 9) x=0;
		sprintf (BUFF,"X%d%d",y,x);
		cella=CercaNomeComando (BUFF);
	}
	if (cella)
	{
		SudoCellOver(cella_old, LeaveNotify);
		SudoCellOver(cella, EnterNotify);
	}

	return (0);
}

int main (int argc, char **argv)
{
	ListCmdInfo *menu[10];
	ListCmdItemInfo *item;
	CmdInfo *button, *timer;
	int ecode=0;

        InitFinestre (argc, argv);
	WX11_INTERLINE_SPACE=4;

	EVIDENCE_BG=BLU_ARDESIA_SCURO;//GRIGIO80;//BLU_ACCIAIO;
	EVIDENCE=0;
	strcpy (MOUSEOVER,"X00");

	COLOR_THEME=0;

#ifdef START_WITH_CANDI
	SHOW_CANDI=1;
#else
	SHOW_CANDI=0;
#endif
#ifdef START_WITH_SOLVE
	SOLVE_MODE=1;
#else
	SOLVE_MODE=0;
#endif
#ifdef START_WITH_FULL_GAME
	FULL_GAME=1;
#else
	FULL_GAME=0;
#endif



	if (WX11_GetDepth ()< 15)
	{
		sprintf (BUFF,"Warning!!!\nYou must have 15 or more bit depth color! You have %d-bit now!",WX11_GetDepth ());
		WX11_Alert (BUFF,"Ok",NULL);
	}

#define LOCALEDIR DIR_PO

	setlocale (LC_ALL, "");
	bindtextdomain (PACKAGE, LOCALEDIR);
	textdomain (PACKAGE);

	///////////////////////
	// Reading confing $home/.xsoduky 
	xsudoky_config_reading_file (&COLOR_THEME,&SHOW_CANDI,&SOLVE_MODE,&FULL_GAME);

	///////////////////////
	// Main Window
	mio=ApreFinestraCentrale (PACKAGE, 790,440);
	WX11_SetClientMessage (mio,SudokyEnd,NULL);
	WX11_SetSignalCallBack (mio,KeyPress,Sudokey,NULL);

	///////////////////////
	// Reset Main Window 
	SudokyFullHalfTable (NULL);

	///////////////////////
	// Areas
	area_table=ApreArea (mio,5,25,410,410,WX11_ColorGet(WINBG),WX11_ColorGet(WINFG),2);
	area_sudo =ApreArea (area_table,5,5,400,400,NERO,WX11_ColorGet(WINFG),2);
	area_logo =ApreArea (area_sudo,5,4,50,50,NERO,WX11_ColorGet(WINFG),0);
        area_others=ApreArea (mio,425,25,360,410,WX11_ColorGet(WINBG),WX11_ColorGet(WINFG),2);
        area_shortinfo=area_others;
	area_history=ApreArea (area_others,3,250,350,30,WX11_ColorGet(WINBG),WX11_ColorGet(WINFG),2);
	area_history->BUpDn=0;
	area_cmd  =ApreArea (area_others,3,285,350,117,WX11_ColorGet(WINBG),WX11_ColorGet(WINFG),2);
	area_cmd->BUpDn=0;


	///////////////////////
	// History Buttons
	button=ApreBottone(area_history,  3, 3,25,25,"<<");
	WX11_SetSignalCallBack (button,Button1Release,MoveSavedTop,NULL);

	button=ApreBottone(area_history, 33, 3,25,25,"<");
	WX11_SetSignalCallBack (button,Button1Release,MoveSavedDn,NULL);

	button=ApreBottone(area_history,293, 3,25,25,">");
	WX11_SetSignalCallBack (button,Button1Release,MoveSavedUp,NULL);

	button=ApreBottone(area_history,323, 3,25,25,">>");
	WX11_SetSignalCallBack (button,Button1Release,MoveSavedBottom,NULL);


	///////////////////////
	// Menu File
	menu[0]=WX11_ListCmdAdd (gettext("File"));
	item=WX11_ListCmdItemAdd (menu[0], MENU_ITEM, gettext("New"));
	WX11_MenuCallBack (item,SudokuNuovo,"");
	WX11_MenuHotKey (menu[0],item,"(Ctrl+N)");

	item=WX11_ListCmdItemAdd (menu[0], MENU_ITEM, gettext("Open..."));
	WX11_MenuCallBack (item,SudokyApri,NULL);
	WX11_MenuHotKey (menu[0],item,"(Ctrl+O)");
	
	item=WX11_ListCmdItemAdd (menu[0], MENU_ITEM, gettext("Create"));
	WX11_MenuCallBack (item,SudokuCreate,NULL);

	item=WX11_ListCmdItemAdd (menu[0], MENU_ITEM, gettext("Save..."));
	WX11_MenuCallBack (item,SudokySalva,NULL);
	WX11_MenuHotKey (menu[0],item,"(Ctrl+S)");

	item=WX11_ListCmdItemAdd (menu[0], MENU_ITEM, gettext("Print..."));
	WX11_MenuCallBack (item,SudokyStampa,NULL);
	WX11_MenuHotKey (menu[0],item,"(Ctrl+P)");

	item=WX11_ListCmdItemAdd (menu[0], MENU_ITEM, gettext("Exit"));
	WX11_MenuCallBack (item,SudokyEnd,NULL);
	WX11_MenuHotKey (menu[0],item,"(Ctrl+Q)");


	///////////////////////
	// Menu Setting
	menu[1]=WX11_ListCmdAdd (gettext("Edit"));

        item=WX11_ListCmdItemAdd (menu[1], MENU_ITEM, gettext("Undo"));
	WX11_MenuCallBack (item,MoveSavedDn,NULL);
	WX11_MenuHotKey (menu[1],item,"(Ctrl+Z)");

	item=WX11_ListCmdItemAdd (menu[1], MENU_ITEM, gettext("Do"));
	WX11_MenuCallBack (item,MoveSavedUp,NULL);
	WX11_MenuHotKey (menu[1],item,"(Ctrl+Shift+Z)");



	///////////////////////
	// Menu Setting
	menu[2]=WX11_ListCmdAdd (gettext("View"));
	item=WX11_ListCmdItemAdd (menu[2], MENU_ITEM, gettext("Change Colors"));
	WX11_MenuCallBack (item,SudoImpostaColore,NULL);

        item=WX11_ListCmdItemAdd (menu[2], MENU_ITEM, gettext("Show Candidates"));
	WX11_MenuCallBack (item,SudokySHOW_CANDI,NULL);
	WX11_MenuHotKey (menu[2],item,"(F9)");
	item->select=&SHOW_CANDI;

	item=WX11_ListCmdItemAdd (menu[2], MENU_ITEM, gettext("Full Game"));
	WX11_MenuCallBack (item,SudokyFullHalfTable,NULL);
	WX11_MenuHotKey (menu[2],item,"(F11)");
	item->select=&FULL_GAME;


	///////////////////////
	// Menu Help
	menu[3]=WX11_ListCmdAdd (gettext("Help"));
	item=WX11_ListCmdItemAdd (menu[3], MENU_ITEM, gettext("How To Play"));
	WX11_MenuCallBack (item,ReadReadMe,NULL);

	item=WX11_ListCmdItemAdd (menu[3], MENU_ITEM, gettext("Info XSudoky"));
	WX11_MenuCallBack (item,SudoInfo,NULL);

	item=WX11_ListCmdItemAdd (menu[3], MENU_ITEM, gettext("License"));
	WX11_MenuCallBack (item,SudoLicense,NULL);


	WX11_Menu(mio,&menu[0],4);

	///////////////////////
	// Methods Buttons
	button=ApreBottone(area_cmd, 10, 10,150,20,"Single Candidate");
        WX11_SetSignalCallBack (button,Button1Release,SingleCandidate,NULL);

	button=ApreBottone(area_cmd,175, 10,150,20,"Intersection");
        WX11_SetSignalCallBack (button,Button1Release,IntersectionRemoval,NULL);

	button=ApreBottone(area_cmd, 10, 35,150,20,"Naked");
        WX11_SetSignalCallBack (button,Button1Release,Naked,NULL);

	button=ApreBottone(area_cmd,175, 35,150,20,"Hidden");
        WX11_SetSignalCallBack (button,Button1Release,Hidden,NULL);

	button=ApreBottone(area_cmd, 10, 60,150,20,"Fish");
        WX11_SetSignalCallBack (button,Button1Release,Fish,NULL);

	//button=ApreBottone(area_cmd,175, 60,150,20,"Chains");
        //WX11_SetSignalCallBack (button,Button1Release,Chains,NULL);

	button=ApreBottone(area_cmd,175, 60,150,20,"XYWing");
        WX11_SetSignalCallBack (button,Button1Release,XYWing,NULL);

	//button=ApreBottone(area_cmd, 10, 85,150,20,"XYWing");
        //WX11_SetSignalCallBack (button,Button1Release,XYWing,NULL);

	button=ApreBottone(area_cmd, 10, 85,150,20,"XYZWing");
        WX11_SetSignalCallBack (button,Button1Release,XYZWing,NULL);

	//button=ApreBottone(area_cmd,175, 85,150,20,"XYZWing");
	//WX11_SetSignalCallBack (button,Button1Release,XYZWing,NULL);

	button=ApreBottone(area_cmd,175, 85,150,20,"Backtrack");
	WX11_SetSignalCallBack (button,Button1Release,SudoBackTrace,NULL);

	
	button=ApreBottone(area_cmd, 20,300,150,20,"???");
	WX11_SetSignalCallBack (button,Button1Release,NULL,NULL);

	WX11_ScrollBar (area_cmd,1);


	///////////////////////
	//  Labels Prints & Timer CallBack
	strcpy (FILENAME," ");

	sprintf (vuoti,"%2d ",VUOTI);
	WX11_Say (area_shortinfo,gettext("empty="));
	label_vuoti=WX11_Say(area_shortinfo,vuoti);
	
	WX11_Say(area_shortinfo,"%20s"," ");

	strcpy(ctimer,"00:00:00");
	//timer=WX11_Say (area_shortinfo,"%s",ctimer);
 	timer=WX11_Print (mio,340,5,ctimer);
	WX11_Say(area_shortinfo,"\n\n");
	timer_s=SetTimerCallBack(SudoShowTime,timer,1000000);
	//timer_s=SetTimerCallBack(SudoShowTime,timer,10000);
	
        WX11_CheckBoxOpen (CHECK_BOX, area_shortinfo, 0, 19, 200 , 20, WX11_ColorGet(WINBG) , WX11_ColorGet(WINFG),1, gettext("Solve Mode"), &SOLVE_MODE);


	///////////////////////
	// ListBox
	ViewComment=WX11_ListCmdAdd ("Sudo");
	WX11_SetSignalCallBack (ViewComment,EnterNotify,SudoListBoxCallBack,NULL);
	WX11_SetSignalCallBack (ViewComment,LeaveNotify,SudoListBoxCallBack,NULL);
	WX11_FontOpen (FONTCOMMENT);
	WX11_ListBox (area_others,ViewComment, 350, 206, NULL);
	WX11_FontOpen (FONTDEFAULT);


	///////////////////////
	// Draw Game
	sudo_start ();

	///////////////////////
	// Reset Main Window 
	SudoImpostaColore (NULL);
	
	if (argv[1]) 
		ecode=SudokuLoad (argv[1]);
	else
		SudokuNuovo(NULL);

	if (!ecode)
		WX11_Events (mio);

	xsudoky_config_writing_file (&COLOR_THEME,&SHOW_CANDI,&SOLVE_MODE,&FULL_GAME);

	WX11_CloseDisplay ();

	return (ecode);

}

