#include <libintl.h>
#include <locale.h>
#include <dirent.h>
#include <sys/stat.h>
#include <sys/dir.h>
#include <ctype.h>
#include <unistd.h>

#include <finestre.h>
#include "config.h"

/*

        FEDCBA9876543210
        +--+|||+-------+  cell's numbers (bits 0..8)
          | ||+---------  not used
          | |+----------  Is Candidate   (bit 10)
          | +-----------  Is Fixed       (bit 11)
          +-------------  not used
*/

#define PACKAGE "xsudoky"

#define FONTDEFAULT	"9x15"
#define FONTBIG  	"10x20" // "12x24" // "10x20"
#define FONTSMALL 	"6x10" // "6x10" // "7x13"
#define FONTCOMMENT	"6x10" // "6x10" // "7x13"
#define FIXED_COLOR 	BIANCO
#define CANDI_COLOR 	GIALLO

#define START_WITH_CANDI
//#define START_WITH_SOLVE
#define START_WITH_FULL_GAME
//"/usr/local/share/xsudoky/"
#define _DIR_DAT DATADIR "/" PACKAGE "/"
#define DIR_SAVED _DIR_DAT "saved"
#define DIR_GAMES _DIR_DAT "games" 
#define DIR_PO	  _DIR_DAT "po"

#define	SUD_TAB		9	// Tavola 9x9
#define DIVX		3	// divisione elementi per cella x
#define DIVY		3	// divisione elementi per cella y

#define CANDI_MSK	1<<(10)	// Flag Candidati
#define FIXED_MSK	1<<(11) // Flag Fixed Number


// Global
int SUD_BUF[SUD_TAB][SUD_TAB];		// Table Bit Sudoky
char BUFF [128];			// Buffer Temp
char FILENAME[32];			// File Corrente 
int VUOTI;				// Contatore
int MAXSAVED;				//
int CORSAVED;				//
int EVIDENCE;				// Numero/Candidato evidenziato
int EVIDENCE_BG;
char MOUSEOVER[3];



// Global X
CmdInfo *mio,				// area principale
	*area_table,			// area table
	*area_sudo,			// area game
        *area_others,                   // area others
	*area_logo,			// area logo
	*area_shortinfo,		// area filename && empty
	*area_history,			// area history
	*area_cmd,			// area comandi
	*area_subcmd,			// area sub comandi
	*label_vuoti,			// Comando x Label
	*label_filename,		// Comando x Label
	*CmdHideShow,			// Bottone Hide/Show
	*CmdSolve,			// Bottone Solve
	*CmdStep			// Cmd Step (Do&UnDo)
	;
					
ListCmdInfo *ViewComment;		// ListBox Comments

char LABELCELL [SUD_TAB*SUD_TAB*5];	// Nome della cella (yx)
char LABELCOLONNA[SUD_TAB][3+1];	// C1, C2, C3... C9
char LABELRIGA   [SUD_TAB][3+1];	// R1, R2, R3... R9
char vuoti[4];				// Label VUOTI
char STEP[10];				// Label Step
int SHOW_CANDI;				// Flag SHOWCANDI (displaing)
int SOLVE_MODE;				// Deduce / Solve
int FULL_GAME;				// Full Game
int COLOR_THEME;			// 

// Funzioni  utili
int ResetGame (int value);
int Redisplay (int Mode);
int SudoListBoxCallBack();
int SudokuNuovo (char *firsttime);
int CaricaGame (char *filename);
int Salva (char *filename);
int SudokyStampa();
int IsSymmetric ();
int IsCandiExist (int y, int x, int candidato);
int RemoveCandidati ();
int IsFixed (int y,int x);
int IsCandi (int y,int x);
int IsEvidence (int y, int x);
int GetCandidato(int bits);
char *GetCandidati(int y, int x);
char *GetCandidati2(int b);
int ContaBits (int b);
int IsOnly1Candi (int b);
int CandiExist (int cell,int candi);
int IsMouseOver (int y,int x);

int xsudoky_config_writing_file (int *COLOR_THEME,int *SHOWCANDI,int *SOLVE_MODE,int *FULL_GAME);
int xsudoky_config_reading_file (int *COLOR_THEME,int *SHOWCANDI,int *SOLVE_MODE,int *FULL_GAME);

int MoveSavedDn ();
int MoveSavedTop ();
int MoveSavedUp ();
int MoveSavedBottom ();
int DoSaved ();
char * extract_filename (char *pathname, char *filename);

int *AddCandidato (int *cella, int candidato);
int *RemoveCandidato (int *cella, int candidato);
int *SetFlagCandidato (int *cella, int Mask);
int *UnsetFlagCandidato (int *cella, int Mask);
int *CoordinateBlocco2yx (int Blocco, int Posizione, int *y, int *x);
int *Coordinateyx2Blocco (int y,int x, int *Blocco, int *Posizione);
int InsertNumeroGUI(int y,int x,int candidato,int step);
int RemoveCandidatoGUI(int y,int x,int candidato,int step);
int CheckAll ();
void SetCellBackGroundColor (CmdInfo *cella);
int SudoEvidence (CmdInfo *cella);

// 
int test ();
int SudoFinish (int Save);
void Clear_Comments ();

// methods
int SingleCandidate ();
int IntersectionRemoval ();
int Naked ();
int Hidden ();
int Fish ();
int Chains ();
int XYWing ();
int XYZWing();
int SudoBackTrace ();


